﻿/*
 _____   _                 _                     
| ____| | |  _   _   ___  (_)  _   _   _ __ ___  
|  _|   | | | | | | / __| | | | | | | | '_ ` _ \ 
| |___  | | | |_| | \__ \ | | | |_| | | | | | | |
|_____| |_|  \__, | |___/ |_|  \__,_| |_| |_| |_|
             |___/                               
*/

const conf = new JsonConfigFile("./plugins/Elysium/config/config.json");
const config = conf.init("config", {});

let lang = config.语言;

const LANG = new JsonConfigFile(`./plugins/Elysium/Lang/${lang}.json`)
const Lang = LANG.init("LANG", {});

let ORI_ERROR = Lang.ori_error,
    MODESWITCH_COMMAND = Lang.modeswitch_command;

//player
let nick = true,
    deathmode = true,
    fly = true,
    speed = true,
    gamemode = true,
    plinfo = true,
    scale = true,
    god = true,
    offhand = true,
    afk = true;

try {
    const Nick = require(`./Elysium/Player/Nick.js`);
} catch {
    nick = false;
};

try {
    const DeathMode = require(`./Elysium/Player/DeathMode.js`);
} catch {
    deathmode = false;
};

try {
    const Fly = require(`./Elysium/Player/Fly.js`);
} catch {
    fly = false;
};

try {
    const Speed = require(`./Elysium/Player/Speed.js`);
} catch {
    speed = false;
};

try {
    const GameMode = require(`./Elysium/Player/GameMode.js`);
} catch {
    gamemode = false;
};

try {
    const PlInfo = require(`./Elysium/Player/PlayerInformation.js`);
} catch {
    plinfo = false;
};

try {
    const Scale = require(`./Elysium/Player/Scale.js`);
} catch {
    scale = false;
};

try {
    const God = require(`./Elysium/Player/God.js`);
} catch {
    god = false;
};

try {
    const Offhand = require(`./Elysium/Player/Offhand.js`);
} catch {
    offhand = false;
};

try {
    const Afk = require(`./Elysium/Player/Afk.js`);
} catch {
    afk = false;
};

//Capabilities
let menu = true,
    sign = true,
    item = true,
    throwSieve = true,
    moreCommand = true,
    chunkArmorStand = true,
    optp = true,
    tick = true,
    spawn = true,
    tps = true,
    ping = true,
    tpa = true,
    motd = true;

try {
    const MENU = require(`./Elysium/Capabilities/Menu.js`);
} catch {
    menu = false;
};

try {
    const Sign = require(`./Elysium/Capabilities/Sign.js`);
} catch {
    sign = false;
};

try {
    const Item = require(`./Elysium/Capabilities/Item.js`);
} catch {
    item = false;
};

try {
    const ThrowSieve = require(`./Elysium/Capabilities/ThrowSieve.js`);
} catch {
    throwSieve = false;
};

try {
    const MoreCommand = require(`./Elysium/Capabilities/MoreCommand.js`);
} catch {
    moreCommand = false;
};

try {
    const ChunkArmorStand = require(`./Elysium/Capabilities/ChunkArmorStand.js`);
} catch {
    chunkArmorStand = false;
};

try {
    const OPTP = require(`./Elysium/Capabilities/OPTP.js`);
} catch {
    optp = false;
};

try {
    const Tick = require(`./Elysium/Capabilities/Tick.js`);
} catch {
    tick = false;
};

try {
    const Spawn = require(`./Elysium/Capabilities/Spawn.js`);
} catch {
    spawn = false;
};

try {
    const Tps = require(`./Elysium/Capabilities/Tps.js`);
} catch {
    tps = false;
};

try {
    const Ping = require(`./Elysium/Capabilities/Ping.js`);
} catch {
    ping = false;
};

try {
    const Tpa = require(`./Elysium/Capabilities/Tpa.js`);
} catch {
    tpa = false;
};

try {
    const Motd = require(`./Elysium/Capabilities/Motd.js`)
} catch {
    motd = false;
}

const PLUGINS_NAME = "Elysium";
const PLUGINS_URI = "https://github.com/XT-xiaotong/Elysium";
const PLUGINS_AUTHOR = "xiaotong";
const PLUGINS_VERSION = "1.3.0-beta";

colorLog("pink", `
         _____   _                 _                     
        | ____| | |  _   _   ___  (_)  _   _   _ __ ___  
        |  _|   | | | | | | / __| | | | | | | | '_ ' _ \\
        | |___  | | | |_| | \\__ \\ | | | |_| | | | | | | |
        |_____| |_|  \\__, | |___/ |_|  \\__,_| |_| |_| |_|
                    |___/
               
    -------- ${PLUGINS_URI} --------
         By: ${PLUGINS_AUTHOR}     Plugins: ${PLUGINS_NAME}       Version: ${PLUGINS_VERSION}
`)

mc.listen("onJoin", (player) => {
    player.sendToast('进服通知', '手持钟右键可打开主菜单')
});

//插件主命令
mc.listen("onServerStarted", () => {
    const ELYSIUM = mc.newCommand("elysium", `${MODESWITCH_COMMAND}`, PermType.Any);
    ELYSIUM.setAlias("es");
    ELYSIUM.setEnum("mode", ["list", "help", "me", "version"]);
    ELYSIUM.mandatory("mode", ParamType.Enum, "mode", 1);
    ELYSIUM.mandatory("name", ParamType.RawText);
    ELYSIUM.overload(["mode"]);
    ELYSIUM.setCallback((_cmd, ori, out, res) => {
        switch (res.mode) {
            case "list":
                if (ori.player) {
                    ori.player.tell(`成功加载以下模块:
1. 名称修改模块 ${nick ? "§a✔§r" : "§4✘§r"}
2. 死神模式模块 ${deathmode ? "§a✔§r" : "§4✘§r"}
3. 玩家飞行模块 ${fly ? "§a✔§r" : "§4✘§r"}
4. 速度修改模块 ${speed ? "§a✔§r" : "§4✘§r"}
5. 模式修改模块 ${gamemode ? "§a✔§r" : "§4✘§r"}
6. 信息查询模块 ${plinfo ? "§a✔§r" : "§4✘§r"}
7. 大小修改模块 ${scale ? "§a✔§r" : "§4✘§r"}
8. 上帝模式模块 ${god ? "§a✔§r" : "§4✘§r"}
9. 主副手切换模块 ${offhand ? "§a✔§r" : "§4✘§r"}
10. 玩家挂机模块 ${afk ? "§a✔§r" : "§4✘§r"}
11. 主菜单模块 ${menu ? "§a✔§r" : "§4✘§r"}
12. 签到模块 ${sign ? "§a✔§r" : "§4✘§r"}
13. 掉落物清理模块 ${item ? "§a✔§r" : "§4✘§r"}
14. 掷筛子模块 ${throwSieve ? "§a✔§r" : "§4✘§r"}
15. 更多指令模块 ${moreCommand ? "§a✔§r" : "§4✘§r"}
16. 区块盔甲架模块 ${chunkArmorStand ? "§a✔§r" : "§4✘§r"}
17. 管理TP菜单模块 ${optp ? "§a✔§r" : "§4✘§r"}
18. 游戏刻调节模块 ${tick ? "§a✔§r" : "§4✘§r"}
19. 返回出生点模块 ${spawn ? "§a✔§r" : "§4✘§r"}
20. 服务器TPS查询模块 ${tps ? "§a✔§r" : "§4✘§r"}
21. 延迟查询模块 ${ping ? "§a✔§r" : "§4✘§r"}
22. 玩家互传模块 ${tpa ? "§a✔§r" : "§4✘§r"}
23. 服务器Motds模块 ${motd ? "§a✔§r" : "§4✘§r"}`);
                } else if (!ori.player) {
                    log(`成功加载以下模块:
1. 名称修改模块 ${nick ? "§a✔§r" : "§4✘§r"}
2. 死神模式模块 ${deathmode ? "§a✔§r" : "§4✘§r"}
3. 玩家飞行模块 ${fly ? "§a✔§r" : "§4✘§r"}
4. 速度修改模块 ${speed ? "§a✔§r" : "§4✘§r"}
5. 模式修改模块 ${gamemode ? "§a✔§r" : "§4✘§r"}
6. 信息查询模块 ${plinfo ? "§a✔§r" : "§4✘§r"}
7. 大小修改模块 ${scale ? "§a✔§r" : "§4✘§r"}
8. 上帝模式模块 ${god ? "§a✔§r" : "§4✘§r"}
9. 主副手切换模块 ${offhand ? "§a✔§r" : "§4✘§r"}
10. 玩家挂机模块 ${afk ? "§a✔§r" : "§4✘§r"}
11. 主菜单模块 ${menu ? "§a✔§r" : "§4✘§r"}
12. 签到模块 ${sign ? "§a✔§r" : "§4✘§r"}
13. 掉落物清理模块 ${item ? "§a✔§r" : "§4✘§r"}
14. 掷筛子模块 ${throwSieve ? "§a✔§r" : "§4✘§r"}
15. 更多指令模块 ${moreCommand ? "§a✔§r" : "§4✘§r"}
16. 区块盔甲架模块 ${chunkArmorStand ? "§a✔§r" : "§4✘§r"}
17. 管理TP菜单模块 ${optp ? "§a✔§r" : "§4✘§r"}
18. 游戏刻调节模块 ${tick ? "§a✔§r" : "§4✘§r"}
19. 返回出生点模块 ${spawn ? "§a✔§r" : "§4✘§r"}
20. 服务器TPS查询模块 ${tps ? "§a✔§r" : "§4✘§r"}
21. 延迟查询模块 ${ping ? "§a✔§r" : "§4✘§r"}
22. 玩家互传模块 ${tpa ? "§a✔§r" : "§4✘§r"}
23. 服务器Motds模块 ${motd ? "§a✔§r" : "§4✘§r"}`)
                } break;
        }
        if (res.mode == "version") {
            if (ori.player) {
                ori.player.tell(`Elysium插件版本为 v${PLUGINS_VERSION}`);
            } else if (!ori.player) {
                log(`Elysium插件版本为 v${PLUGINS_VERSION}`);
            }
        }
        if (res.mode == "help") {
            if (ori.player) {
                ori.player.tell(`-------------------
Elysium插件帮助:           
1. 指令 elysium help 插件帮助
2. 指令 elysium list 获取功能列表
3. 指令 elysium me 获取我的信息
4. 指令 elysium version 获取插件版本
5. 指令 deathmode或dm 开启或关闭死神模式
6. 指令 fly 开启或关闭飞行模式
7. 指令 god 开启或关闭无敌模式
8. 指令 item 查看掉落物和箭矢数量
9. 指令 menu 打开主菜单
10. 指令 modeswitch或g 修改玩家游戏模式
11. 指令 nick 修改玩家昵称
12. 指令 optp 打开传送菜单[需要op权限]
13. 指令 playerinformation或者pi 获取玩家详细信息
14. 指令 scale 修改玩家大小
15. 指令 sdl,tql,awsl,wbs.damn,pa,ssb,sds,shen 发送特殊消息
16. 指令 sign 打开签到菜单
17. 指令 spawn 回到出生点
18. 指令 speed 修改玩家移动速度
19. 指令 throwsieve或ts 掷出筛子
20. 指令 tick 修改游戏tick
21. 指令 offhand 主副手物品切换
22. 指令 tps 获取服务器TPS
23. 指令 ping 获取延迟
24. 指令 tpa 玩家互传
25. 指令 afk 挂机
-------------------`)
            } else if (!ori.player)
                log(`
-------------------
1. 指令 elysium help 插件帮助
2. 指令 elysium list 获取功能列表
3. 指令 elysium me 获取我的信息
4. 指令 elysium version 获取插件版本
5. 指令 deathmode或dm 开启或关闭死神模式
6. 指令 fly 开启或关闭飞行模式
7. 指令 god 开启或关闭无敌模式
8. 指令 item 查看掉落物和箭矢数量
9. 指令 menu 打开主菜单
10. 指令 modeswitch或g 修改玩家游戏模式
11. 指令 nick 修改玩家昵称
12. 指令 optp 打开传送菜单[需要op权限]
13. 指令 playerinformation或者pi 获取玩家详细信息
14. 指令 scale 修改玩家大小
15. 指令 sdl,tql,awsl,wbs.damn,pa,ssb,sds,shen 发送特殊消息
16. 指令 sign 打开签到菜单
17. 指令 spawn 回到出生点
18. 指令 speed 修改玩家移动速度
19. 指令 throwsieve或ts 掷出筛子
20. 指令 tick 修改游戏tick
21. 指令 offhand 主副手物品切换
22. 指令 tps 获取服务器TPS
23. 指令 ping 获取延迟
24. 指令 tpa 玩家互传
25. 指令 afk 挂机
-------------------`)
        }
        if (res.mode == "me") {
            if (!ori.player) return out.error(ORI_ERROR);
            let gameMode = ori.player.gameMode;
            let perm = ori.player.permLevel;
            switch (gameMode) {
                case 0:
                    gameMode = "生存";
                    break;
                case 1:
                    gameMode = "创造";
                    break;
                case 2:
                    gameMode = "冒险";
                    break;
                case 6:
                    gameMode = "旁观";
            }
            switch (perm) {
                case 0:
                    perm = "成员";
                    break;
                case 1:
                    perm = "管理员";
                    break;
            }
            ori.player.tell(`你的信息:
玩家名: ${ori.player.name}
游戏模式: ${gameMode}
权限: ${perm}
        `)
        }
    });
    ELYSIUM.setup();
});

mc.listen("onServerStarted", function () {
    logger.log(`加载成功! v${PLUGINS_VERSION}  作者:${PLUGINS_AUTHOR} 感谢使用!`);
});